<template>
  <div>
    <div v-for="(question, indexQuestions) in questionsList" :key="indexQuestions" style="padding: 5px;">
      <v-container fill-height fluid>
        <v-row>
          <v-col>
            <div :class="[ question.require ? 'label-answer required': 'label-answer' ]" style="">{{ question.question }}</div>
            <div v-if="question.form_type === 'SHORTTEXT'" class="">
              <ValidationProvider v-slot="{ errors }" :rules="question.require ? 'required': '' ">
                <v-text-field
                  :error-messages="errors"
                  v-model="question.answer"
                  @change="onAnswer(indexQuestions, question.answer)"
                />
              </ValidationProvider>
            </div>
            <div v-if="question.form_type === 'MULTI_CHOICE'" class="">
              <ValidationProvider v-slot="{ errors }" :rules="question.require ? 'required': '' ">
                <v-radio-group
                  v-model="question.answer"
                  :error-messages="errors"
                  @change="onAnswer(indexQuestions, question.answer)"
                >
                  <v-radio
                    v-for="(n, indexOptions) in question.options"
                    :key="indexOptions"
                    :label="`${n.body}`"
                    :value="n"
                  />
                </v-radio-group>
              </ValidationProvider>
            </div>
            <div v-if="question.form_type === 'CHECKBOX'" class="" style="margin-top: 1.2rem;">
              <ValidationProvider v-slot="{ errors }" :rules="question.require ? 'required|atLeastOne': '' ">
                <div v-for="(option, indexOptions) in question.options" :key="indexOptions">
                  <label class="material-checkbox-custom">
                    <input
                      :value="option"
                      v-model="question.answer"
                      type="checkbox"
                    >
                    <span v-if="errors.length" class="error--text">{{ option.body }}</span>
                    <span v-else>{{ option.body }}</span>
                  </label>
                </div>
                <span
                  v-if="errors.length"
                  class="v-messages error--text"
                >{{ errors[0] }}</span>
              </ValidationProvider>
            </div>
            <div v-if="question.form_type === 'ADDRESS'">
              <type-questions-address
                :required-address="question.require"
                :answer-questions="question.answer"
              />
            </div>
          </v-col>
        </v-row>
      </v-container>
    </div>
  </div>
</template>

<script>
import { ValidationProvider } from 'vee-validate'
export default {
  name: 'SurveyQuestionsViews',
  components: {
    ValidationProvider
  },
  props: {
    questionsList: {
      type: Array,
      default: null
    }
  },
  data() {
    return {
      rules: {
        atLeastOneSkill: (question) => question.answer.length > 0 || this.$t('errors.field_must_be_filled')
      }
    }
  },
  methods: {
    onAnswer(index, value) {
      this.$emit('answer', index)
    }
  }
}
</script>
<style scoped>
.label-answer {
  font-weight: 500;
  font-size: 14px;
  color: #333333;
}
.required::after {
  content: " *";
  color: red;
}

.buttons-section {
  padding-top: 50px;
}
.buttons-required {
  padding-left: 50px;
}
</style>
